import { csv, select } from 'd3';
import { scatterPlot } from './scatterPlot';

// importing the data through url link
const csvUrl = [
  'https://gist.githubusercontent.com/',
  'curran/', // User
  'a08a1080b88344b0c8a7/', // Id of the Gist
  'raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/', // commit
  'iris.csv', // File name
].join('');

// getting the data from each column
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  return d;
};

//declaring the dimention of the whole picture
const width = window.innerWidth;
const height = window.innerHeight;
const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);
const xValue = (d) => d.petal_length;
const yValue = (d) => d.petal_width;
const rxValue = (d) => d.sepal_length;
const ryValue = (d) => d.sepal_width;
const speciesValue = (d) => d.species;
const colorValue = d => d.species;
const colorLabel = 'Species';


const main = async () => {
  
  
  
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(await csv(csvUrl, parseRow))
  //defining the x and y axis values and defininhg the margin fro the garph to locate
    .xValue((d) => d.petal_width)
    .yValue((d) => d.sepal_length)
  	.symbolValue((d) => d.species)
    .margin({
      top: 40,
      right: 20,
      bottom: 100,
      left: 100,
    })
    .size(100);
  
  const g = svg.append('g')
          .attr('transform', `translate(${100},${100})`);

      const colorLegendG = g.append('g')
          .attr('transform', `translate(${100}, 150)`);
//shape of that scattered data 



  
  

  svg.call(plot);

  const columns = [
    'petal_width',
    'sepal_width',
    'petal_length',
    'sepal_length',
  ];
  let i = 0;
 //changing x-value in each interval, ie, if i =0, x=petal_width
  //if i = 1, xvalue = sepal width and so on
  setInterval(() => {
    plot.xValue((d) => d[columns[i % columns.length]]);
    
    svg.selectAll('text').remove();
    svg.call(plot);
    	//puting the title of legend and its formatting
    	colorLegendG.append('text')
          .attr('class', 'legend-label')
          .attr('x', -70)
          .attr('y', -210)
          .style("font-style","italic")
          .style("stroke","blue")
          .text(colorLabel);
    
// display Title 
svg.append("text").attr("x", 450).attr("y", 20).text("Iris Scatterplot").style("font-size", "40px").attr("alignment-baseline","middle")

   

 //displaying the y-label 
		svg
        	.append("text")
        	.attr('transform', 'rotate(-90)')
        	.attr('x',0 - (height /2))
        	.attr("y",  height/12)
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
        	.text("Sepal Length");
    

    
  //putting legend for the data
    //defining color and symbol for legend
    var legendData = [
         ["Sentosa", "red", "circle"],
         ["Versicolor", "green", "cross"],
         ["Virginica", "blue", "diamond"]
       ];

  

       var legend = svg.append("g")
         .attr("class", "legend")
         .attr("height", 0)
         .attr("width", 0)
         .attr('transform', 'translate(20,250)');
//getting the co-ordinates of the symbol
    //using the symbol of the legends
       svg.selectAll('.symbol')
         .data(legendData)
         .enter()
         .append('path')
         .attr('transform', function(d, i) {
           return 'translate(' + (120) + ',' + ((i * 30) + 70) + ')';
         })
         .attr('d', d3.symbol().type(function(d, i) {
             if (d[2] === "circle") {
               return d3.symbolCircle;
             } else if (d[2] === "cross") {
               return d3.symbolCross;
             } else if (d[2] === "diamond") {
               return d3.symbolDiamond;
             }
           })
           .size(100))
         .style("fill", function(d) {
           return d[1];
         });

//getting the label names 
       svg.selectAll('.label')
         .data(legendData)
         .enter()
         .append('text')
    		 .style("fontFamily","Sans-serif")
         .attr("x", "130")
         .attr("y", function(d, i){ return ((i * 30)+80);})
         .text(function(d) {
           return d[0];
         });
   // putting  x-axis label as petal width
    if(i % columns.length==0) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  460 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Petal Width");
      // putting x-axis label as Sepal Width
    else if(i % columns.length==1) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  460 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Sepal Width");
     // putting x-axis label as Petal length
    else if(i % columns.length==2) 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  460 )
        	.style("text-anchor", "middle")
        	.style("font-weight","bold")
      		.text("Petal Length");
     // putting x-axis label as Sepal length
       else 
    svg
        	.append("text")
        	.attr("x", width / 2 )
      		.attr("y",  460 )
        	.style("text-anchor", "middle")
        	.style("font-style","italic")
        	.style("font-weight","bold")
      		.text("Sepal Length");
   

    
    
    i++;
  }, 2000);
};
main();



